﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Business
{
    public class WerkNemerRepository
    {
        public List<Werknemer> GetLoonLijst()
        {
            Bediende b = new Bediende(2900); //maandloon meegeven in constructor
            Arbeider a = new Arbeider(15); //uurloon meegeven in constructor
            a.UrenGewerkt = 160;  //aantal uren bij een arbeider achteraf invullen via Property
            List<Werknemer> werknemers = new List<Werknemer>();
            werknemers.Add(a);
            werknemers.Add(b);
            return werknemers;
        }
    }
    public abstract class Werknemer
    {
        public abstract decimal Loon { get; }
    }

    public class Bediende : Werknemer
    {
        private decimal maandloon;
        public Bediende(decimal maandloon)
        {
            this.maandloon = maandloon;
        }

        public override decimal Loon
        {
            get { return maandloon; }
        }
    }
    public class Arbeider : Werknemer
    {
        private decimal uurloon;
        public int UrenGewerkt { get; set; }

        public Arbeider(decimal uurloon)
        {
            this.uurloon = uurloon;
        }
        public override decimal Loon
        {
            get { return uurloon * UrenGewerkt; }
        }
    }

}
